

/************************************************************************
   Unrooted REConciliation version 1.00 
   (c) Copyright 2005-2006 by Pawel Gorecki
   Written by P.Gorecki.
   Permission is granted to copy and use this program provided no fee is
   charged for it and provided that this copyright notice is not removed. 
*************************************************************************/

#include <ctype.h>
#include <iostream>

using namespace std;

#include "rtree.h"

double weight_loss=1.0;
double weight_dup=1.0;

char* getTok(char *s,int &p)
{
#define inctok p++
    while (isspace(s[p])) inctok;
    char *cur = s+p;
    if (isalpha(s[p]))
    {
	while (isalnum(s[p])) inctok;
	return cur;
    }
    if ((s[p]=='(')  || (s[p]==')') || (s[p]==','))
    {
	inctok;
	return cur;
    }
    cerr << "Parse error..." << endl;
    exit(-1);
}

iterator_tree::iterator_tree(RTree *tr, int flag_) 
{ 
    t=tr; 
    c=tr->root(); 
    flag=flag_;
}

RNode *RTree::parseNode(char *s,int &p)
{
    char *cur = getTok(s,p);
    if (cur[0]=='(')
    {
	RNode *a = parseNode(s,p);
	getTok(s,p);
	RNode *b = parseNode(s,p);
	getTok(s,p);
	return createInt(a,b);
    }
    return createLeaf(cur,s+p-cur);
}


RTree::RTree(char *fs)
{
    int px=0;
    rootn=parseNode(fs,px);
    rootn->depth(0);
}

RNode *iterator_tree::operator()()
{
    RNode *res = step();
    while (res)
    {
	if (flag & F_ALL) break;
	if ((flag & F_INTERNAL) && (!res->leaf())) break;
	if ((flag & F_LEAVES) && (res->leaf())) break;
	res=step();
    }
    return res;
}

RNode *iterator_tree::step()
{
    RNode *res=c;
    if (!c) return c;  // finished
    if (!c->leaf()) c=((RInt*)c)->l();
    else
    {
	while (c)	    
	{
	    RNode *prev=c;
	    c=c->p();
	    if (!c) break; // last
	    if ((((RInt*)c)->l())==prev) { 
		c=((RInt*)c)->r();
		break;
	    }
	}
    }
    return res;
}


RNode *SpeciesTree::lca(RNode *a, RNode *b) { 
    if (b->isParentOf(a)) return b;
    while (a) 
    {
	if (a->isParentOf(b)) return a;
	a=a->p();
    }
    return NULL;
}

RNode *RNode::isParentOf(RNode *c) 
{ 
    while (c) { 
	if (c==this) return c; 
	c=c->p();
    } 
    return 0;
}

char* xstrndup(const char *s,int len)
{
    if (len==0) return strdup(s);
    char *b = new char[len+1];
    strncpy(b,s,len);
    b[len]=0;
    return b;
}
